--------------------------------------------------------------------------------
-- Copyright (c) 1995-2007 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 9.2.02i
--  \   \         Application : sch2vhdl
--  /   /         Filename : StopWatch.vhf
-- /___/   /\     Timestamp : 10/06/2007 13:48:18
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: C:\Xilinx92i\bin\nt\sch2vhdl.exe -intstyle ise -family spartan3e -flat -suppress -w D:/BASYS_PROJECTS/PROBLEMS/Prob4/StoipWatch_Solution/StopWatch.sch StopWatch.vhf
--Design Name: StopWatch
--Device: spartan3e
--Purpose:
--    This vhdl netlist is translated from an ECS schematic. It can be 
--    synthesis and simulted, but it should not be modified. 
--

library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity StopWatch is
   port ( Clear     : in    std_logic; 
          Clk       : in    std_logic; 
          Lap       : in    std_logic; 
          StartStop : in    std_logic; 
          An        : out   std_logic_vector (3 downto 0); 
          Led       : out   std_logic_vector (7 downto 0); 
          Seg       : out   std_logic_vector (1 to 8));
end StopWatch;

architecture BEHAVIORAL of StopWatch is
   attribute BOX_TYPE   : string ;
   signal BcdMin    : std_logic_vector (7 downto 0);
   signal BcdSec    : std_logic_vector (7 downto 0);
   signal LapTime   : std_logic;
   signal StSt      : std_logic;
   signal XLXN_1    : std_logic;
   signal XLXN_2    : std_logic;
   signal XLXN_14   : std_logic;
   signal XLXN_17   : std_logic;
   signal XLXN_38   : std_logic_vector (3 downto 0);
   signal XLXN_39   : std_logic_vector (7 downto 0);
   signal XLXN_46   : std_logic_vector (15 downto 0);
   signal XLXN_51   : std_logic_vector (3 downto 0);
   signal XLXN_52   : std_logic;
   component Cnt59
      port ( En    : in    std_logic; 
             Clr   : in    std_logic; 
             Clk   : in    std_logic; 
             Rco   : out   std_logic; 
             Bcd59 : out   std_logic_vector (7 downto 0));
   end component;
   
   component Cnt999
      port ( En      : in    std_logic; 
             Clr     : in    std_logic; 
             Clk     : in    std_logic; 
             Rco     : out   std_logic; 
             Bcd1_10 : out   std_logic_vector (3 downto 0));
   end component;
   
   component TeenthSec
      port ( Bcd1_10 : in    std_logic_vector (3 downto 0); 
             Leds    : out   std_logic_vector (7 downto 0));
   end component;
   
   component Toggle_Button3
      port ( Clk    : in    std_logic; 
             Button : in    std_logic; 
             Toggle : out   std_logic; 
             Deboun : out   std_logic; 
             Pulse  : out   std_logic);
   end component;
   
   component Lap_Time_Latch
      port ( Latch   : in    std_logic; 
             Bcd1_10 : in    std_logic_vector (7 downto 0); 
             BcdSec  : in    std_logic_vector (7 downto 0); 
             BcdMin  : in    std_logic_vector (7 downto 0); 
             Leds    : out   std_logic_vector (7 downto 0); 
             Bcd     : out   std_logic_vector (15 downto 0));
   end component;
   
   component muxdisplay_ver3
      port ( Clk_50MHz : in    std_logic; 
             Bcd       : in    std_logic_vector (15 downto 0); 
             Dp        : in    std_logic_vector (3 downto 0); 
             Clk_1kHz  : out   std_logic; 
             Segm      : out   std_logic_vector (1 to 8); 
             An        : out   std_logic_vector (3 downto 0));
   end component;
   
   component AND2B1
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of AND2B1 : component is "BLACK_BOX";
   
   component Blinking
      port ( StartStop : in    std_logic; 
             Lap       : in    std_logic; 
             HalfSec   : in    std_logic; 
             Dp        : out   std_logic_vector (3 downto 0));
   end component;
   
begin
   XLXI_4 : Cnt59
      port map (Clk=>XLXN_17,
                Clr=>XLXN_14,
                En=>XLXN_2,
                Bcd59(7 downto 0)=>BcdMin(7 downto 0),
                Rco=>open);
   
   XLXI_5 : Cnt999
      port map (Clk=>XLXN_17,
                Clr=>XLXN_14,
                En=>StSt,
                Bcd1_10(3 downto 0)=>XLXN_38(3 downto 0),
                Rco=>XLXN_1);
   
   XLXI_10 : TeenthSec
      port map (Bcd1_10(3 downto 0)=>XLXN_38(3 downto 0),
                Leds(7 downto 0)=>XLXN_39(7 downto 0));
   
   XLXI_16 : Toggle_Button3
      port map (Button=>StartStop,
                Clk=>XLXN_17,
                Deboun=>open,
                Pulse=>open,
                Toggle=>StSt);
   
   XLXI_17 : Toggle_Button3
      port map (Button=>Lap,
                Clk=>XLXN_17,
                Deboun=>open,
                Pulse=>open,
                Toggle=>LapTime);
   
   XLXI_18 : Lap_Time_Latch
      port map (BcdMin(7 downto 0)=>BcdMin(7 downto 0),
                BcdSec(7 downto 0)=>BcdSec(7 downto 0),
                Bcd1_10(7 downto 0)=>XLXN_39(7 downto 0),
                Latch=>LapTime,
                Bcd(15 downto 0)=>XLXN_46(15 downto 0),
                Leds(7 downto 0)=>Led(7 downto 0));
   
   XLXI_19 : muxdisplay_ver3
      port map (Bcd(15 downto 0)=>XLXN_46(15 downto 0),
                Clk_50MHz=>Clk,
                Dp(3 downto 0)=>XLXN_51(3 downto 0),
                An(3 downto 0)=>An(3 downto 0),
                Clk_1kHz=>XLXN_17,
                Segm(1 to 8)=>Seg(1 to 8));
   
   XLXI_20 : Toggle_Button3
      port map (Button=>Clear,
                Clk=>XLXN_17,
                Deboun=>open,
                Pulse=>XLXN_52,
                Toggle=>open);
   
   XLXI_21 : AND2B1
      port map (I0=>StSt,
                I1=>XLXN_52,
                O=>XLXN_14);
   
   XLXI_22 : Blinking
      port map (HalfSec=>BcdSec(3),
                Lap=>LapTime,
                StartStop=>StSt,
                Dp(3 downto 0)=>XLXN_51(3 downto 0));
   
   XLXI_23 : Cnt59
      port map (Clk=>XLXN_17,
                Clr=>XLXN_14,
                En=>XLXN_1,
                Bcd59(7 downto 0)=>BcdSec(7 downto 0),
                Rco=>XLXN_2);
   
end BEHAVIORAL;


